##################################################
# BigInt IA-32 Assembler Backend                 #
# (C) 1999-2003 The Botan Project                #
##################################################

#define WORD_BITS_NEEDED 32
#include <botan/mp_asm.h>

.text

##################################################
# void bigint_add2(word* const x, u32bit x_size, #
#                  const word* y, u32bit y_size) #
##################################################
FUNCTION(bigint_add2)
        pushl   %ebp
        xorl    %ecx, %ecx
        movl    %esp, %ebp
        pushl   %edi
        pushl   %esi
        subl    $16, %esp
        movl    20(%ebp), %eax  #  y_size
        movl    $0, -12(%ebp)   #  carry
        cmpl    %eax, %ecx
        je      .L15
        SET_ALIGN
.L6:
        movl    8(%ebp), %edx   #  x
        movl    16(%ebp), %edi  #  y
        movl    (%edx,%ecx,4), %eax     #  sum
        movl    (%edi,%ecx,4), %esi
        xorl    %edx, %edx
        xorl    %edi, %edi
        addl    %esi, %eax      #  sum
        movl    -12(%ebp), %esi #  carry,  carry
        adcl    %edi, %edx
        xorl    %edi, %edi
        addl    %esi, %eax      #  carry,  sum
        adcl    %edi, %edx
        movl    8(%ebp), %edi   #  x
        movl    %edx, -12(%ebp) #  sum,  carry
        movl    %eax, (%edi,%ecx,4)     #  sum
        incl    %ecx    #  j
        cmpl    20(%ebp), %ecx  #  y_size,  j
        jne     .L6
.L15:
        movl    -12(%ebp), %eax #  carry
        testl   %eax, %eax
        je      .L1
        movl    20(%ebp), %edx  #  y_size,  j
        cmpl    12(%ebp), %edx  #  x_size,  j
        je      .L17
        SET_ALIGN
.L13:
        movl    8(%ebp), %ecx   #  x
        movl    (%ecx,%edx,4), %eax
        incl    %eax
        testl   %eax, %eax
        movl    %eax, (%ecx,%edx,4)
        jne     .L1
        incl    %edx    #  j
        cmpl    12(%ebp), %edx  #  x_size,  j
        jne     .L13
.L17:
        movl    12(%ebp), %eax  #  x_size
        movl    8(%ebp), %esi   #  x
        incl    (%esi,%eax,4)
.L1:
        addl    $16, %esp
        popl    %esi
        popl    %edi
        leave
        ret

##################################################
# void bigint_add3(word* const z,                #
#                  const word* x, u32bit x_size, #
#                  const word* y, u32bit y_size) #
##################################################
FUNCTION(bigint_add3)
        pushl   %ebp
        movl    %esp, %ebp
        pushl   %edi
        pushl   %esi
        subl    $16, %esp
        movl    24(%ebp), %eax  #  y_size
        cmpl    %eax, 16(%ebp)  #  x_size
        jae     .L19
        movl    12(%ebp), %eax  #  x,  t_ptr
        movl    20(%ebp), %ecx  #  y
        movl    24(%ebp), %edx  #  y_size
        movl    %eax, 20(%ebp)  #  t_ptr,  y
        movl    %ecx, 12(%ebp)  #  x
        movl    16(%ebp), %eax  #  x_size,  t_size
        movl    %edx, 16(%ebp)  #  x_size
        movl    %eax, 24(%ebp)  #  t_size,  y_size
.L19:
        movl    24(%ebp), %eax  #  y_size
        xorl    %ecx, %ecx
        movl    $0, -12(%ebp)   #  carry
        cmpl    %eax, %ecx
        je      .L34
        SET_ALIGN
.L24:
        movl    12(%ebp), %edx  #  x
        movl    20(%ebp), %edi  #  y
        movl    (%edx,%ecx,4), %eax     #  sum
        movl    (%edi,%ecx,4), %esi
        xorl    %edx, %edx
        xorl    %edi, %edi
        addl    %esi, %eax      #  sum
        movl    -12(%ebp), %esi #  carry,  carry
        adcl    %edi, %edx
        xorl    %edi, %edi
        addl    %esi, %eax      #  carry,  sum
        adcl    %edi, %edx
        movl    8(%ebp), %edi   #  z
        movl    %edx, -12(%ebp) #  sum,  carry
        movl    %eax, (%edi,%ecx,4)     #  sum
        incl    %ecx    #  j
        cmpl    24(%ebp), %ecx  #  y_size,  j
        jne     .L24
.L34:
        movl    24(%ebp), %esi  #  y_size,  j
        cmpl    16(%ebp), %esi  #  x_size,  j
        je      .L26
        movl    16(%ebp), %eax  #  x_size
        cld
        subl    %esi, %eax      #  j
        leal    0(,%eax,4), %edx
        SET_ALIGN
.L32:
        movl    -12(%ebp), %eax #  carry
        testl   %eax, %eax
        je      .L36
        movl    12(%ebp), %eax  #  x
        movl    (%eax,%esi,4), %ecx
        movl    8(%ebp), %eax   #  z
        addl    %ecx, -12(%ebp) #  carry
        xorl    %ecx, %ecx
        movl    -12(%ebp), %edi #  carry
        movl    %edi, (%eax,%esi,4)
        movl    12(%ebp), %eax  #  x
        cmpl    $-1, (%eax,%esi,4)
        sete    %cl
        incl    %esi    #  j
        subl    $4, %edx
        cmpl    16(%ebp), %esi  #  x_size,  j
        movl    %ecx, -12(%ebp) #  carry
        jne     .L32
.L26:
        movl    8(%ebp), %esi   #  z
        movl    -12(%ebp), %edx #  carry
        movl    16(%ebp), %eax  #  x_size
        movl    %edx, (%esi,%eax,4)
        addl    $16, %esp
        popl    %esi
        popl    %edi
        leave
        ret
.L36:
        leal    0(,%esi,4), %eax
        movl    12(%ebp), %ecx  #  x
        movl    8(%ebp), %esi   #  z
        leal    (%esi,%eax), %edi
        leal    (%ecx,%eax), %esi
        movl    %edx, %ecx
        shrl    $2, %ecx
        testl   $2, %edx
        rep
        movsl
        je      .L30
        movzwl  (%esi), %eax
        addl    $2, %esi
        movw    %ax, (%edi)
        addl    $2, %edi
.L30:
        andl    $1, %edx
        je      .L26
        movzbl  (%esi), %ecx
        movb    %cl, (%edi)
        jmp     .L26

##################################################
# void bigint_sub2(word* const x, u32bit x_size, #
#                  const word* y, u32bit y_size) #
##################################################
FUNCTION(bigint_sub2)
        pushl   %ebp
        xorl    %ecx, %ecx
        movl    %esp, %ebp
        pushl   %edi
        pushl   %esi
        subl    $16, %esp
        cmpl    20(%ebp), %ecx  #  y_size,  borrow
        movl    $0, -12(%ebp)   #  j
        je      .L54
        SET_ALIGN
.L44:
        movl    -12(%ebp), %esi #  j
        movl    8(%ebp), %edx   #  x
        movl    %esi, %edi
        movl    (%edx,%esi,4), %eax     #  temp
        movl    16(%ebp), %esi  #  y
        xorl    %edx, %edx
        movl    (%esi,%edi,4), %esi
        xorl    %edi, %edi
        subl    %esi, %eax      #  temp
        sbbl    %edi, %edx
        movl    %ecx, %edi      #  borrow,  borrow
        xorl    %ecx, %ecx
        subl    %edi, %eax      #  borrow,  temp
        movl    8(%ebp), %edi   #  x
        sbbl    %ecx, %edx
        addl    $0, %eax        #  temp
        adcl    $1, %edx
        xorl    %ecx, %ecx      #  borrow
        testl   %edx, %edx
        movl    -12(%ebp), %edx #  j
        sete    %cl
        movl    %eax, (%edi,%edx,4)     #  temp
        movl    20(%ebp), %eax  #  y_size
        incl    %edx
        movl    %edx, -12(%ebp) #  j
        cmpl    %eax, %edx
        jne     .L44
.L54:
        movl    20(%ebp), %edi  #  y_size
        movl    12(%ebp), %eax  #  x_size
        cmpl    %eax, %edi
        movl    %edi, -16(%ebp) #  j
        je      .L37
        SET_ALIGN
.L52:
        testl   %ecx, %ecx      #  borrow
        je      .L37
        movl    -16(%ebp), %edi #  j
        movl    8(%ebp), %edx   #  x
        movl    8(%ebp), %esi   #  x
        movl    (%edx,%edi,4), %eax     #  temp
        movl    %ecx, %edi      #  borrow,  borrow
        xorl    %edx, %edx
        xorl    %ecx, %ecx
        subl    %edi, %eax      #  borrow,  temp
        sbbl    %ecx, %edx
        addl    $0, %eax        #  temp
        adcl    $1, %edx
        xorl    %ecx, %ecx      #  borrow
        testl   %edx, %edx
        movl    -16(%ebp), %edx #  j
        sete    %cl
        movl    %eax, (%esi,%edx,4)     #  temp
        movl    12(%ebp), %eax  #  x_size
        incl    %edx
        movl    %edx, -16(%ebp) #  j
        cmpl    %eax, %edx
        jne     .L52
.L37:
        addl    $16, %esp
        popl    %esi
        popl    %edi
        leave
        ret

##################################################
# void bigint_sub3(word* const z,                #
#                  const word* x, u32bit x_size, #
#                  const word* y, u32bit y_size) #
##################################################
FUNCTION(bigint_sub3)
.LFB4:
        pushl   %ebp
        xorl    %ecx, %ecx
        movl    %esp, %ebp
        pushl   %edi
        pushl   %esi
        subl    $24, %esp
        cmpl    24(%ebp), %ecx  #  y_size,  borrow
        movl    $0, -12(%ebp)   #  j
        je      .L75
        SET_ALIGN
.L63:
        movl    -12(%ebp), %esi #  j
        movl    12(%ebp), %edx  #  x
        movl    %esi, %edi
        movl    (%edx,%esi,4), %eax     #  temp
        movl    20(%ebp), %esi  #  y
        xorl    %edx, %edx
        movl    (%esi,%edi,4), %esi
        xorl    %edi, %edi
        subl    %esi, %eax      #  temp
        sbbl    %edi, %edx
        movl    %ecx, %edi      #  borrow,  borrow
        xorl    %ecx, %ecx
        subl    %edi, %eax      #  borrow,  temp
        movl    8(%ebp), %edi   #  z
        sbbl    %ecx, %edx
        addl    $0, %eax        #  temp
        adcl    $1, %edx
        xorl    %ecx, %ecx      #  borrow
        testl   %edx, %edx
        movl    -12(%ebp), %edx #  j
        sete    %cl
        movl    %eax, (%edi,%edx,4)     #  temp
        movl    24(%ebp), %eax  #  y_size
        incl    %edx
        movl    %edx, -12(%ebp) #  j
        cmpl    %eax, %edx
        jne     .L63
.L75:
        movl    24(%ebp), %edx  #  y_size
        movl    16(%ebp), %esi  #  x_size
        cmpl    %esi, %edx
        movl    %edx, -16(%ebp) #  j
        je      .L56
        movl    %esi, %edi
        subl    %edx, %edi
        sall    $2, %edi
        cld
        movl    %edi, -20(%ebp)
        SET_ALIGN
.L73:
        testl   %ecx, %ecx      #  borrow
        je      .L77
        movl    -16(%ebp), %edi #  j
        movl    12(%ebp), %edx  #  x
        movl    8(%ebp), %esi   #  z
        movl    (%edx,%edi,4), %eax     #  temp
        movl    %ecx, %edi      #  borrow,  borrow
        xorl    %edx, %edx
        xorl    %ecx, %ecx
        subl    %edi, %eax      #  borrow,  temp
        sbbl    %ecx, %edx
        addl    $0, %eax        #  temp
        adcl    $1, %edx
        xorl    %ecx, %ecx      #  borrow
        testl   %edx, %edx
        movl    -16(%ebp), %edx #  j
        sete    %cl
        subl    $4, -20(%ebp)
        movl    %eax, (%esi,%edx,4)     #  temp
        movl    16(%ebp), %eax  #  x_size
        incl    %edx
        movl    %edx, -16(%ebp) #  j
        cmpl    %eax, %edx
        jne     .L73
.L56:
        addl    $24, %esp
        popl    %esi
        popl    %edi
        leave
        ret
.L77:
        movl    -16(%ebp), %eax #  j
        movl    12(%ebp), %ecx  #  x
        movl    8(%ebp), %esi   #  z
        sall    $2, %eax
        leal    (%esi,%eax), %edi
        leal    (%ecx,%eax), %esi
        movl    -20(%ebp), %ecx
        shrl    $2, %ecx
        rep
        movsl
        testl   $2, -20(%ebp)
        je      .L69
        movzwl  (%esi), %eax
        addl    $2, %esi
        movw    %ax, (%edi)
        addl    $2, %edi
.L69:
        testl   $1, -20(%ebp)
        je      .L56
        movzbl  (%esi), %edx
        movb    %dl, (%edi)
        jmp     .L56
